
#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Aqua
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Silver
#property indicator_color5 Silver
#property indicator_color6 Silver
#property indicator_color7 Yellow

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame=240;
extern string Currency;
extern int MAPeriod=8;
extern int ma_shift=0;
extern int ma_method=MODE_SMA;
extern int applied_price=PRICE_CLOSE;
extern bool UseLevels=False;
extern int Level0=0;
extern int Level1=0;
extern int Level2=0;
extern int Level3=0;
extern int Level4=0;
extern int Level5=0;


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double Buffer[];
   int i, limit;
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  //Draw();
 
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(6,DRAW_LINE);

//----
   return(0);
 }
//+------------------------------------------------------------------+
//| MTF Moving Average                                   |
//+------------------------------------------------------------------+
int start()
  {
ObjectsDeleteAll();
      Draw();
      

   return(0);
  }
//+------------------------------------------------------------------+


void Draw()
{
//-------------------

limit=Bars;//-IndicatorCounted();
   limit = 500;//To limit data during debugging...

      i= limit;
      
      int X, Xa, Xb, pi;
      double Y, Ya, Yb;
  
      while(i>=0)//Store HTF data in array:
         {     
         int Bar_Shift=iBarShift(NULL,TimeFrame,Time[i],false);
         ExtMapBuffer2[i]=iMA(Currency,TimeFrame,MAPeriod,ma_shift,ma_method,applied_price,Bar_Shift) ; //Red line
         i--;
         }  
 
      //+--------------------------------------------------+
      //Linear interpolation equation:
      //Controlpoints (known data) are: Xa,Ya and Xb,Yb
      //For any given value of X, Y will be:
      //Y = Ya + (X - Xa) * ( (Yb - Ya) / (Xb - Xa) )
      //+--------------------------------------------------+
      i= limit; 
      while(i>=0)
         {          
         if(ExtMapBuffer2[i] != ExtMapBuffer2[i+1] )//We struck a new controlpoint
            {
            //DrawVline(Yellow, Time[i]);//debug
            //Capture current point data (Xb / Yb) and previous point data (Xa / Ya):
            Xa = pi;//X value of previous CP
            Ya = ExtMapBuffer2[Xa];//Y value of previous CP
            Xb = i;//X value of current CP
            Yb = ExtMapBuffer2[Xb];//Y value of current CP
            pi = i;//Store current location for future ref
            //i--;
            }
            
            //Print("i:  ",i,"  Y: ",Y,"  Xa: ",Xa,"  Ya: ",Ya,"  Xb: ",Xb,"  Yb: ",Yb);
       
         
            //Now we have the two controlpoints, and can start interpolating between them :
            X = i-1;//??
            Y = Ya +  ( (X - Xb) * ( (Yb - Ya) / (Xb - Xa) ) );
            //Y = Ya + (Xb - X) * ( (Ya - Yb) / (Xa - Xb) );
            Print("X:  ",X,"  Y: ",Y,"  Xa: ",Xa,"  Ya: ",Ya,"  Xb: ",Xb,"  Yb: ",Yb);
 
            ExtMapBuffer1[i] = Y; //Aqua line
    
    
         i--;
         }  
       
//Comment("ddd:  ", Bar_Shift);
 

//-------------------
return(0);
}



//-----------------------------------------------------------
void DrawVline (color Color, datetime time)
   {//Use: DrawVline(Yellow, Time[i]);
   static int cntr;
   static double PrevVlineTime;
   if (time == PrevVlineTime) return(0);//Still on same bar
      ObjectCreate( "UpLine"+cntr, OBJ_VLINE, 0, time, 0);
      ObjectSet("UpLine"+cntr, OBJPROP_COLOR, Color);
      ObjectSet("UpLine"+cntr, OBJPROP_BACK,true);
      cntr++;
      PrevVlineTime = time;//Store bar time of last drawn line
   return(0);
   }     
//-----------------------------------------------------------  